//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Chat Emotes - By Destiny
//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Main Prefs
//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
$Emotes::Count = 0;
//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Emote Data
//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
function Emotes_LoadAll()
{
   for(%file = findFirstFile("Add-Ons/Script_Emotes/Emotes/*.png"); %file !$= ""; %file = findNextFile("Add-Ons/Script_Emotes/Emotes/*.png"))
   {
      %fileName = strReplace(%file, "Add-Ons/Script_Emotes/Emotes/", "");
      %emoteFile = %fileName;
      %fileName = strReplace(%fileName, ".png", "");
      %decalName = %fileName @ "Emote";
      datablock DecalData(EmoteData)
      {
         textureName = %file;
      };
      EmoteData.setName(%decalName);
      $Emotes::Count++;
      $Emotes::Name[$Emotes::Count] = ":" @ %fileName @ ":";
      $Emotes::File[$Emotes::Count] = %emoteFile;
   }
}
schedule(1000,0,"Emotes_LoadAll");
//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
// Emote Scripts
//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*
function testForEmotes(%string)
{
   %wordcount = getWordCount(%string);
   for(%j=0; %j<%wordcount; %j++)
   {
      for(%i=0; %i<=$Emotes::Count; %i++)
      {
         if(getword(%string,%j) $= $Emotes::Name[%i])
         {
            return true;
         }
      }
   }
   return false;
}
package ChatEmotes
{
   function serverCmdMessageSent(%c,%msg)
   {
      %testemotes = testForEmotes(%msg);
      if(%testemotes == true)
      {
         messageAll('',"\c7"@%c.clanPrefix@"\c3"@$NamePrefix[%c.bl_id]@%c.name@$NameSuffix[%c.bl_id]@"\c7"@%c.clanSuffix@"\c6: "@subEmotes(%msg));
      }
      else
      {
         Parent::serverCmdMessageSent(%c,%msg);
      }
   }
};
activatepackage(ChatEmotes);
function subEmotes(%msg)
{
   %text = "";
   while(%text !$= %msg)
   {
      %text = %msg;
      %msg = stripMLControlChars(%msg);
   }
   for(%i=0;%i<=$Emotes::Count;%i++)
   {
      %msg = strReplace(%msg,$Emotes::Name[%i],"<bitmap:Add-Ons/Script_Emotes/Emotes/" @ $Emotes::File[%i] @ ">");
   }
   return %msg;
}

function serverCmdCheckEmotes(%client)
{
   messageclient(%client,'','The server currently has \c4%1\c0 emotes.',$Emotes::Count);
   for(%i=0;%i<=$Emotes::Count;%i++)
   {
      %emoteDirectory = "<bitmap:Add-Ons/Script_Emotes/Emotes/" @ $Emotes::File[%i] @ ">\c6";
      %emoteName = $Emotes::Name[%i];
      messageclient(%client,'','%1 - \c4%2',%emoteDirectory,%emoteName);
   }
}
//-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*